<template>
  <div class="register-page">
    <div class="module">
      <div class="left">
        <img class="logo" src="../assets/logo.png" alt="">
        <p class="p1">算法竞赛开赛</p>
        <p class="p2">提醒聚合站</p>
        <a-divider/>
        <p class="description">为用户提供订阅、推荐及推送提醒服务。通过平台，让算法竞赛爱好者们可以更加快速、便捷、及时地获知各种竞赛的消息。</p>
      </div>
      <div class="right">
        <div class="title">
          <span>注册</span>
          <p>已有账号？<span @click="$router.back()">点此登录</span></p>
        </div>
        <div class="form">
          <a-form-model ref="form" :model="formData" :rules="formRules">
            <a-form-model-item></a-form-model-item>
            <a-form-model-item prop="username">
              <a-input v-model="formData.username" allowClear size="large"
                       :maxLength="32"
                       placeholder="用户名(不能超过32个字符)">
                <a-icon slot="prefix" type="user" style="color:#517E55"/>
              </a-input>
            </a-form-model-item>
            <a-form-model-item prop="password">
              <a-input-password v-model="formData.password" allowClear visibilityToggle size="large" type="password"
                                :maxLength="16"
                                placeholder="请输入8-16位字母和数字">
                <a-icon slot="prefix" type="lock" style="color:#517E55"/>
              </a-input-password>
            </a-form-model-item>
            <a-form-model-item prop="confirmPassword">
              <a-input-password v-model="formData.confirmPassword" allowClear visibilityToggle size="large"
                                type="password" placeholder="确认密码">
                <a-icon slot="prefix" type="lock" style="color:#517E55"/>
              </a-input-password>
            </a-form-model-item>
            <a-form-model-item v-if="registerType == 'email'" prop="mail">
              <a-input v-model="formData.mail" allowClear size="large" placeholder="邮箱">
                <a-icon slot="prefix" type="mail" style="color:#517E55"/>
              </a-input>
            </a-form-model-item>
            <a-form-model-item v-if="registerType == 'phone'" prop="phone">
              <a-input v-model="formData.phone" allowClear size="large" :maxLength="11" placeholder="手机号">
                <a-icon slot="prefix" type="phone" style="color:#517E55"/>
              </a-input>
            </a-form-model-item>
            <a-form-model-item prop="code" ref="code" :autoLink="false">
              <div class="code-button">
                <a-input v-model="formData.code" size="large"
                         :maxLength="6"
                         placeholder="验证码"
                         @blur="() => {$refs.code.onFieldBlur()}"
                         @change="() => {$refs.code.onFieldChange()}"></a-input>
                <a-button type="primary"
                          size="large"
                          :loading="codeLoading"
                          :disabled="codeButtonText.includes('秒')" @click="getCode">{{ codeButtonText }}
                </a-button>
              </div>
            </a-form-model-item>
            <a-form-model-item>
              <a @click="checkRegisterType">{{ registerType == 'email' ? '绑定手机号注册' : '绑定邮箱注册' }}</a>
            </a-form-model-item>
            <a-form-model-item>
              <a-button size="large" block type="primary" @click="checkRegister">注 册</a-button>
            </a-form-model-item>
          </a-form-model>
        </div>
      </div>
    </div>
    <a-modal
        :centered="true"
        title="注册成功"
        :visible="successVisible"
        @ok="handleOk">
      <a-result
          status="success"
          title="欢迎来到Let\'s code!"
          sub-title="点击确认键来登录吧！"
      >
      </a-result>
    </a-modal>
  </div>
</template>

<script>
export default {
  data() {
    let validateUsername = (rule, value, callback) => {
      if (!value) {
        return callback(new Error('用户名为必填项'));
      } else {
        this.$axios.post('register/user/check',
            {
              name: this.formData.username
            }).then(res => {
          if (res.code == 0) {
            callback()
          } if (res.code == 501) {
            return callback(new Error(res.info));
          } else {
            return callback(new Error('用户名校验失败'));
          }
        }).catch(() => {
          return callback(new Error('用户名校验失败'));
        })
      }
    }

    let validatePassword = (rule, value, callback) => {
      let reg = /^(?=.*\d)(?=.*[a-zA-Z])[\da-zA-Z]{8,16}$/g
      if (!value) {
        return callback(new Error('密码为必填项'));
      } else if (!reg.test(value)) {
        return callback(new Error('密码必须为8-16位字母和数字的组合'));
      } else {
        if (this.formData.confirmPassword != '') {
          this.$refs.form.validateField('confirmPassword');
        }
        callback();
      }
    }

    let validateConfirmPassword = (rule, value, callback) => {
      if (!value) {
        return callback(new Error('确认密码为必填项'));
      } else if (value != this.formData.password) {
        return callback(new Error('两次密码不一致'));
      } else {
        callback()
      }
    }

    let validateMail = (rule, value, callback) => {
      if (this.registerType === 'phone') {
        return callback()
      }
      if (!value) {
        return callback(new Error('邮箱为必填项'));
      } else if (this.formData.mail.search(/^\w+((-\w+)|(\.\w+))*@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/) == -1) {
        return callback(new Error('邮箱格式错误'));
      } else {
        this.$axios.post('register/email/check',
            {
              email: this.formData.mail
            }).then(res => {
          if (res.code == 0) {
            callback()
          } if (res.code == 501) {
            return callback(new Error(res.info));
          } else {
            return callback(new Error('邮箱校验失败'));
          }
        }).catch(() => {
          return callback(new Error('邮箱校验失败'));
        })
      }
    }

    let validatePhone = (rule, value, callback) => {
      if (this.registerType === 'email') {
        return callback()
      }
      if (!value) {
        return callback(new Error('手机号为必填项'));
      } else if (!/^1[3456789]\d{9}$/.test(this.formData.phone)) {
        return callback(new Error('手机号格式错误'));
      } else {
        this.$axios.post('register/phone/check',
            {
              phonenum: this.formData.phone
            }).then(res => {
          if (res.code == 0) {
            callback()
          } if (res.code == 501) {
            return callback(new Error(res.info));
          } else {
            return callback(new Error('手机号校验失败'));
          }
        }).catch(() => {
          return callback(new Error('手机号校验失败'));
        })
      }
    }
    return {
      showerr: false,
      errorTip: '',
      username: '',
      password: "",
      repassword: "",
      email: '',
      phonenum: '',
      message: [],
      successVisible: false,
      formData: {
        username: "",
        password: "",
        confirmPassword: "",
        mail: "",
        phone: "",
        code: ""
      },
      formRules: {
        username: [{validator: validateUsername, trigger: 'blur'}],
        password: [{validator: validatePassword, trigger: 'blur'}],
        confirmPassword: [{validator: validateConfirmPassword, trigger: 'blur'}],
        mail: [{validator: validateMail, trigger: 'blur'}],
        phone: [{validator: validatePhone, trigger: 'blur'}],
        code: [{required: true, message: '验证码为必填项', trigger: 'blur'}]
      },
      codeButtonText: '获取验证码',
      codeLoading: false,
      codeTimer: null,
      registerType: 'email'
    };
  },
  methods: {
    toLogin() {
      this.$router.push({path: "/login"});
    },
    destroyALL() {
      this.$destroyAll();
    },
    handleOk() {
      this.successVisible = false;
      this.$router.back();
    },
    showSuccess() {
      this.successVisible = true;
    },
    getCode() {
      this.$refs.form.validateField(['mail', 'phone'], async valid => {
        if (!valid) {
          let _this = this
          let count = 59
          let timerFun = () => {
            _this.codeTimer = setTimeout(() => {
              if (count < 0) {
                _this.codeButtonText = '重新获取'
                clearTimeout(_this.codeTimer)
              } else {
                _this.codeButtonText = `还剩 ${count} 秒`
              }
              count--
              timerFun()
            }, 1000)
          }
          _this.codeLoading = true
          let params = {}
          if (this.registerType === 'email') {
            params.email = this.formData.mail
          } else {
            params.phonenum = this.formData.phone
          }
          await _this.$axios.post(`register/${this.registerType}/register_code`,
              params).then(res => {
            if (res.code == 0) {
              timerFun()
            } else {
              _this.$message.error('验证码发送失败，请重新获取')
            }
          }).catch(() => {
          })
          _this.codeLoading = false
        }
      })
    },

    checkRegisterType() {
      this.$refs.form.clearValidate()
      if (this.registerType === 'email') {
        this.registerType = 'phone'
      } else {
        this.registerType = 'email'
      }
    },

    checkRegister() {
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$axios.post('register', {
            name: this.formData.username,
            password: this.formData.password,
            phonenum: this.registerType === 'phone' ? this.formData.phone : undefined,
            email: this.registerType === 'email' ? this.formData.mail : undefined,
            register_code: this.formData.code
          }).then(res => {
            if (res.code == 0) {
              this.successVisible = true
            } else if (res.code == 501) {
              this.$message.error(res.info)
            } else {
              this.$message.error('注册失败!')
            }
          }).catch(() => {
            this.$message.error('注册失败!')
          })
        }
      })
    }
  }
}
</script>

<style lang="less" scoped>
.register-page {
  height: 100%;
  background-image: url("../assets/login_back.jpeg");
  background-repeat: no-repeat;
  background-size: cover;

  .module {
    position: fixed;
    top: 12%;
    left: 50%;
    transform: translateX(-50%);
    display: flex;

    .left {
      width: 400px;
      background: #517E55;
      padding: 30px 60px;
      box-sizing: border-box;

      .logo {
        transform: scale(1.2);
        display: block;
        margin: 20px auto 30px auto;
      }

      p {
        font-size: 25px;
        font-weight: bold;
        color: #ffffff;

        &.p2 {
          text-align: right;
        }
      }

      .description {
        font-size: 14px;
        font-weight: normal;
        margin-top: 40px;
        line-height: 24px;
      }
    }

    .right {
      width: 400px;
      background: #ffffff;
      padding: 25px 60px;
      box-sizing: border-box;

      .title {
        display: flex;
        align-items: baseline;
        justify-content: space-between;

        > span {
          font-size: 25px;
          font-weight: bold;
        }

        p {
          span {
            color: #517E55;
            cursor: pointer;
          }
        }
      }

      .form {
        .error {
          margin-bottom: 0;
          background: rgba(255, 0, 0, .1);
          height: 32px;
          line-height: 32px;
          border: 1px solid rgba(255, 0, 0, .5);
          border-radius: 4px;
          padding-left: 10px;
          color: #9F3A38;
        }

        .forgot-pwd {
          cursor: pointer;
          color: #517E55;
          text-align: right;
        }

        .code-button {
          display: flex;

          /deep/ .ant-input {
            border-top-right-radius: 0px;
            border-bottom-right-radius: 0px;
          }

          /deep/ .ant-btn-lg {
            border-top-left-radius: 0px;
            border-bottom-left-radius: 0px;
          }
        }
      }
    }
  }
}

.wrapper {
  display: flex;
  flex-direction: column;
  min-height: 100%;
}

.contenter {
  text-align: center;
  position: absolute;
  width: 100%;
  height: calc(100% - 100px);
  background: rgb(240, 242, 245);
}

.font-control {
  color: crimson;
  font-size: 15px;
  text-align: left;
}
</style>